////////////////////////////////////////////////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////s           www.testbench.in           s////
////s                                      s////
////s              OVM Tutorial            s////
////s                                      s////
////s~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~s////
////////////////////////////////////////////////

class agent extends ovm_agent;
     `ovm_component_utils(agent)
      protected ovm_active_passive_enum is_active = OVM_ACTIVE;
      monitor mon;
      driver drv;

     function new(string name, ovm_component parent);
         super.new(name, parent);
     endfunction

     function void build();
         ovm_report_info(get_full_name(),"Build", OVM_LOG);
         mon = monitor::type_id::create("mon",this);   
         drv = driver::type_id::create("drv",this);   
     endfunction

     function void connect();
         ovm_report_info(get_full_name(),"Connect", OVM_LOG);
     endfunction

     function void end_of_elaboration();
         ovm_report_info(get_full_name(),"End_of_elaboration", OVM_LOG);
     endfunction

     function void start_of_simulation();
         ovm_report_info(get_full_name(),"Start_of_simulation", OVM_LOG);
     endfunction

     task run();
         ovm_report_info(get_full_name(),"Run", OVM_LOG);
     endtask

     function void extract();
         ovm_report_info(get_full_name(),"Extract", OVM_LOG);
     endfunction

     function void check();
         ovm_report_info(get_full_name(),"Check", OVM_LOG);
     endfunction

     function void report();
         ovm_report_info(get_full_name(),"Report", OVM_LOG);
     endfunction

endclass


